Create or update a Container App.
PUT https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.App/containerApps/{containerAppName}?api-version=2026-07-01
URI Parameters
| Name |
In |
Required |
Type |
Description |
|
containerAppName
|
path |
True
|
string
|
Name of the Container App.
|
|
resourceGroupName
|
path |
True
|
string
minLength: 1 maxLength: 90
|
The name of the resource group. The name is case insensitive.
|
|
subscriptionId
|
path |
True
|
string
(uuid)
|
The ID of the target subscription. The value must be an UUID.
|
|
api-version
|
query |
True
|
string
minLength: 1
|
The API version to use for this operation.
|
Request Body
| Name |
Required |
Type |
Description |
|
location
|
True
|
string
|
The geo-location where the resource lives
|
|
extendedLocation
|
|
ExtendedLocation
|
The complex type of the extended location.
|
|
identity
|
|
ManagedServiceIdentity
|
managed identities for the Container App to interact with other Azure services without maintaining any secrets or credentials in code.
|
|
kind
|
|
Kind
|
Metadata to represent the container app kind, representing if a container app is workflowapp or functionapp.
|
|
managedBy
|
|
string
|
The fully qualified resource ID of the resource that manages this resource. Indicates if this resource is managed by another Azure resource. If this is present, complete mode deployment will not delete the resource if it is removed from the template since it is managed by another resource.
|
|
properties.configuration
|
|
Configuration
|
Non versioned Container App configuration properties.
|
|
properties.environmentId
|
|
string
|
Resource ID of environment.
|
|
properties.managedEnvironmentId
|
|
string
|
Deprecated. Resource ID of the Container App's environment.
|
|
properties.networking
|
|
ContainerAppNetworkingConfiguration
|
Networking configuration for the Container App.
|
|
properties.template
|
|
Template
|
Container App versioned application definition.
|
|
properties.workloadProfileName
|
|
string
|
Workload profile name to pin for container app execution.
|
|
tags
|
|
object
|
Resource tags.
|
Responses
| Name |
Type |
Description |
|
200 OK
|
ContainerApp
|
Resource 'ContainerApp' update operation succeeded
|
|
201 Created
|
ContainerApp
|
Resource 'ContainerApp' create operation succeeded
Headers
- Azure-AsyncOperation: string
- Retry-After: integer
|
|
Other Status Codes
|
ErrorResponse
|
An unexpected error response.
|
Security
azure_auth
Azure Active Directory OAuth2 Flow.
Type:
oauth2
Flow:
implicit
Authorization URL:
https://login.microsoftonline.com/common/oauth2/authorize
Scopes
| Name |
Description |
|
user_impersonation
|
impersonate your user account
|
Examples
Create or Update App On A Connected Environment
Sample request
PUT https://management.azure.com/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/containerApps/testcontainerApp0?api-version=2026-07-01
{
"extendedLocation": {
"name": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.ExtendedLocation/customLocations/testcustomlocation",
"type": "CustomLocation"
},
"location": "East US",
"properties": {
"configuration": {
"dapr": {
"appPort": 3000,
"appProtocol": "http",
"enableApiLogging": true,
"enabled": true,
"httpMaxRequestSize": 10,
"httpReadBufferSize": 30,
"logLevel": "debug"
},
"ingress": {
"additionalPortMappings": [
{
"external": true,
"targetPort": 1234
},
{
"exposedPort": 3456,
"external": false,
"targetPort": 2345
}
],
"clientCertificateMode": "accept",
"corsPolicy": {
"allowCredentials": true,
"allowedHeaders": [
"HEADER1",
"HEADER2"
],
"allowedMethods": [
"GET",
"POST"
],
"allowedOrigins": [
"https://a.test.com",
"https://b.test.com"
],
"exposeHeaders": [
"HEADER3",
"HEADER4"
],
"maxAge": 1234
},
"customDomains": [
{
"name": "www.my-name.com",
"bindingType": "SniEnabled",
"certificateId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube/certificates/my-certificate-for-my-name-dot-com"
},
{
"name": "www.my-other-name.com",
"bindingType": "SniEnabled",
"certificateId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube/certificates/my-certificate-for-my-other-name-dot-com"
}
],
"external": true,
"ipSecurityRestrictions": [
{
"name": "Allow work IP A subnet",
"description": "Allowing all IP's within the subnet below to access containerapp",
"action": "Allow",
"ipAddressRange": "192.168.1.1/32"
},
{
"name": "Allow work IP B subnet",
"description": "Allowing all IP's within the subnet below to access containerapp",
"action": "Allow",
"ipAddressRange": "192.168.1.1/8"
}
],
"stickySessions": {
"affinity": "sticky"
},
"targetPort": 3000,
"traffic": [
{
"label": "production",
"revisionName": "testcontainerApp0-ab1234"
}
]
},
"maxInactiveRevisions": 10,
"runtime": {
"java": {
"enableMetrics": true
}
}
},
"environmentId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube",
"template": {
"containers": [
{
"name": "testcontainerApp0",
"image": "repo/testcontainerApp0:v1",
"probes": [
{
"type": "Liveness",
"httpGet": {
"path": "/health",
"httpHeaders": [
{
"name": "Custom-Header",
"value": "Awesome"
}
],
"port": 8080
},
"initialDelaySeconds": 3,
"periodSeconds": 3
}
]
}
],
"initContainers": [
{
"name": "testinitcontainerApp0",
"args": [
"-c",
"while true; do echo hello; sleep 10;done"
],
"command": [
"/bin/sh"
],
"image": "repo/testcontainerApp0:v4",
"resources": {
"cpu": 0.2,
"memory": "100Mi"
}
}
],
"scale": {
"cooldownPeriod": 350,
"maxReplicas": 5,
"minReplicas": 1,
"pollingInterval": 35,
"rules": [
{
"name": "httpscalingrule",
"custom": {
"type": "http",
"metadata": {
"concurrentRequests": "50"
}
}
}
]
}
}
}
}
import com.azure.resourcemanager.appcontainers.models.Action;
import com.azure.resourcemanager.appcontainers.models.Affinity;
import com.azure.resourcemanager.appcontainers.models.AppProtocol;
import com.azure.resourcemanager.appcontainers.models.BindingType;
import com.azure.resourcemanager.appcontainers.models.Configuration;
import com.azure.resourcemanager.appcontainers.models.Container;
import com.azure.resourcemanager.appcontainers.models.ContainerAppProbe;
import com.azure.resourcemanager.appcontainers.models.ContainerAppProbeHttpGet;
import com.azure.resourcemanager.appcontainers.models.ContainerAppProbeHttpGetHttpHeadersItem;
import com.azure.resourcemanager.appcontainers.models.ContainerResources;
import com.azure.resourcemanager.appcontainers.models.CorsPolicy;
import com.azure.resourcemanager.appcontainers.models.CustomDomain;
import com.azure.resourcemanager.appcontainers.models.CustomScaleRule;
import com.azure.resourcemanager.appcontainers.models.Dapr;
import com.azure.resourcemanager.appcontainers.models.ExtendedLocation;
import com.azure.resourcemanager.appcontainers.models.ExtendedLocationTypes;
import com.azure.resourcemanager.appcontainers.models.Ingress;
import com.azure.resourcemanager.appcontainers.models.IngressClientCertificateMode;
import com.azure.resourcemanager.appcontainers.models.IngressPortMapping;
import com.azure.resourcemanager.appcontainers.models.IngressStickySessions;
import com.azure.resourcemanager.appcontainers.models.InitContainer;
import com.azure.resourcemanager.appcontainers.models.IpSecurityRestrictionRule;
import com.azure.resourcemanager.appcontainers.models.LogLevel;
import com.azure.resourcemanager.appcontainers.models.Runtime;
import com.azure.resourcemanager.appcontainers.models.RuntimeJava;
import com.azure.resourcemanager.appcontainers.models.Scale;
import com.azure.resourcemanager.appcontainers.models.ScaleRule;
import com.azure.resourcemanager.appcontainers.models.Template;
import com.azure.resourcemanager.appcontainers.models.TrafficWeight;
import com.azure.resourcemanager.appcontainers.models.Type;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
/**
* Samples for ContainerApps CreateOrUpdate.
*/
public final class Main {
/*
* x-ms-original-file: 2026-07-01/ContainerApps_CreateOrUpdate_ConnectedEnvironment.json
*/
/**
* Sample code: Create or Update App On A Connected Environment.
*
* @param manager Entry point to ContainerAppsApiManager.
*/
public static void createOrUpdateAppOnAConnectedEnvironment(
com.azure.resourcemanager.appcontainers.ContainerAppsApiManager manager) {
manager.containerApps().define("testcontainerApp0").withRegion("East US").withExistingResourceGroup("rg")
.withExtendedLocation(new ExtendedLocation().withName(
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.ExtendedLocation/customLocations/testcustomlocation")
.withType(ExtendedLocationTypes.CUSTOM_LOCATION))
.withEnvironmentId(
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube")
.withConfiguration(new Configuration().withIngress(new Ingress().withExternal(true).withTargetPort(3000)
.withTraffic(Arrays
.asList(new TrafficWeight().withRevisionName("testcontainerApp0-ab1234").withLabel("production")))
.withCustomDomains(Arrays.asList(new CustomDomain().withName("www.my-name.com")
.withBindingType(BindingType.SNI_ENABLED).withCertificateId(
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube/certificates/my-certificate-for-my-name-dot-com"),
new CustomDomain().withName("www.my-other-name.com").withBindingType(BindingType.SNI_ENABLED)
.withCertificateId(
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube/certificates/my-certificate-for-my-other-name-dot-com")))
.withIpSecurityRestrictions(Arrays.asList(
new IpSecurityRestrictionRule().withName("Allow work IP A subnet")
.withDescription("Allowing all IP's within the subnet below to access containerapp")
.withIpAddressRange("192.168.1.1/32").withAction(Action.ALLOW),
new IpSecurityRestrictionRule().withName("Allow work IP B subnet")
.withDescription("Allowing all IP's within the subnet below to access containerapp")
.withIpAddressRange("192.168.1.1/8").withAction(Action.ALLOW)))
.withStickySessions(new IngressStickySessions().withAffinity(Affinity.STICKY))
.withClientCertificateMode(IngressClientCertificateMode.ACCEPT)
.withCorsPolicy(new CorsPolicy()
.withAllowedOrigins(Arrays.asList("https://a.test.com", "https://b.test.com"))
.withAllowedMethods(Arrays.asList("GET", "POST"))
.withAllowedHeaders(Arrays.asList("HEADER1", "HEADER2"))
.withExposeHeaders(Arrays.asList("HEADER3", "HEADER4")).withMaxAge(1234).withAllowCredentials(true))
.withAdditionalPortMappings(
Arrays.asList(new IngressPortMapping().withExternal(true).withTargetPort(1234),
new IngressPortMapping().withExternal(false).withTargetPort(2345).withExposedPort(3456))))
.withDapr(new Dapr().withEnabled(true).withAppProtocol(AppProtocol.HTTP).withAppPort(3000)
.withHttpReadBufferSize(30).withHttpMaxRequestSize(10).withLogLevel(LogLevel.DEBUG)
.withEnableApiLogging(true))
.withRuntime(new Runtime().withJava(new RuntimeJava().withEnableMetrics(true)))
.withMaxInactiveRevisions(10))
.withTemplate(new Template()
.withInitContainers(Arrays.asList(new InitContainer().withImage("repo/testcontainerApp0:v4")
.withName("testinitcontainerApp0").withCommand(Arrays.asList("/bin/sh"))
.withArgs(Arrays.asList("-c", "while true; do echo hello; sleep 10;done"))
.withResources(new ContainerResources().withCpu(0.2D).withMemory("100Mi"))))
.withContainers(
Arrays
.asList(new Container().withImage("repo/testcontainerApp0:v1").withName("testcontainerApp0")
.withProbes(Arrays.asList(new ContainerAppProbe()
.withHttpGet(new ContainerAppProbeHttpGet()
.withHttpHeaders(Arrays.asList(new ContainerAppProbeHttpGetHttpHeadersItem()
.withName("Custom-Header").withValue("Awesome")))
.withPath("/health").withPort(8080))
.withInitialDelaySeconds(3).withPeriodSeconds(3).withType(Type.LIVENESS)))))
.withScale(
new Scale().withMinReplicas(1).withMaxReplicas(5).withCooldownPeriod(350).withPollingInterval(35)
.withRules(Arrays.asList(new ScaleRule().withName("httpscalingrule").withCustom(
new CustomScaleRule().withType("http").withMetadata(mapOf("concurrentRequests", "50")))))))
.create();
}
// Use "Map.of" if available
@SuppressWarnings("unchecked")
private static <T> Map<String, T> mapOf(Object... inputs) {
Map<String, T> map = new HashMap<>();
for (int i = 0; i < inputs.length; i += 2) {
String key = (String) inputs[i];
T value = (T) inputs[i + 1];
map.put(key, value);
}
return map;
}
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
from azure.identity import DefaultAzureCredential
from azure.mgmt.appcontainers import ContainerAppsAPIClient
"""
# PREREQUISITES
pip install azure-identity
pip install azure-mgmt-appcontainers
# USAGE
python container_apps_create_or_update_connected_environment.py
Before run the sample, please set the values of the client ID, tenant ID and client secret
of the AAD application as environment variables: AZURE_CLIENT_ID, AZURE_TENANT_ID,
AZURE_CLIENT_SECRET. For more info about how to get the value, please see:
https://docs.microsoft.com/azure/active-directory/develop/howto-create-service-principal-portal
"""
def main():
client = ContainerAppsAPIClient(
credential=DefaultAzureCredential(),
subscription_id="SUBSCRIPTION_ID",
)
response = client.container_apps.begin_create_or_update(
resource_group_name="rg",
container_app_name="testcontainerApp0",
container_app_envelope={
"extendedLocation": {
"name": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.ExtendedLocation/customLocations/testcustomlocation",
"type": "CustomLocation",
},
"location": "East US",
"properties": {
"configuration": {
"dapr": {
"appPort": 3000,
"appProtocol": "http",
"enableApiLogging": True,
"enabled": True,
"httpMaxRequestSize": 10,
"httpReadBufferSize": 30,
"logLevel": "debug",
},
"ingress": {
"additionalPortMappings": [
{"external": True, "targetPort": 1234},
{"exposedPort": 3456, "external": False, "targetPort": 2345},
],
"clientCertificateMode": "accept",
"corsPolicy": {
"allowCredentials": True,
"allowedHeaders": ["HEADER1", "HEADER2"],
"allowedMethods": ["GET", "POST"],
"allowedOrigins": ["https://a.test.com", "https://b.test.com"],
"exposeHeaders": ["HEADER3", "HEADER4"],
"maxAge": 1234,
},
"customDomains": [
{
"bindingType": "SniEnabled",
"certificateId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube/certificates/my-certificate-for-my-name-dot-com",
"name": "www.my-name.com",
},
{
"bindingType": "SniEnabled",
"certificateId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube/certificates/my-certificate-for-my-other-name-dot-com",
"name": "www.my-other-name.com",
},
],
"external": True,
"ipSecurityRestrictions": [
{
"action": "Allow",
"description": "Allowing all IP's within the subnet below to access containerapp",
"ipAddressRange": "192.168.1.1/32",
"name": "Allow work IP A subnet",
},
{
"action": "Allow",
"description": "Allowing all IP's within the subnet below to access containerapp",
"ipAddressRange": "192.168.1.1/8",
"name": "Allow work IP B subnet",
},
],
"stickySessions": {"affinity": "sticky"},
"targetPort": 3000,
"traffic": [{"label": "production", "revisionName": "testcontainerApp0-ab1234"}],
},
"maxInactiveRevisions": 10,
"runtime": {"java": {"enableMetrics": True}},
},
"environmentId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube",
"template": {
"containers": [
{
"image": "repo/testcontainerApp0:v1",
"name": "testcontainerApp0",
"probes": [
{
"httpGet": {
"httpHeaders": [{"name": "Custom-Header", "value": "Awesome"}],
"path": "/health",
"port": 8080,
},
"initialDelaySeconds": 3,
"periodSeconds": 3,
"type": "Liveness",
}
],
}
],
"initContainers": [
{
"args": ["-c", "while true; do echo hello; sleep 10;done"],
"command": ["/bin/sh"],
"image": "repo/testcontainerApp0:v4",
"name": "testinitcontainerApp0",
"resources": {"cpu": 0.2, "memory": "100Mi"},
}
],
"scale": {
"cooldownPeriod": 350,
"maxReplicas": 5,
"minReplicas": 1,
"pollingInterval": 35,
"rules": [
{
"custom": {"metadata": {"concurrentRequests": "50"}, "type": "http"},
"name": "httpscalingrule",
}
],
},
},
},
},
).result()
print(response)
# x-ms-original-file: 2026-07-01/ContainerApps_CreateOrUpdate_ConnectedEnvironment.json
if __name__ == "__main__":
main()
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
package armappcontainers_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/appcontainers/armappcontainers/v5"
)
// Generated from example definition: 2026-07-01/ContainerApps_CreateOrUpdate_ConnectedEnvironment.json
func ExampleContainerAppsClient_BeginCreateOrUpdate_createOrUpdateAppOnAConnectedEnvironment() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armappcontainers.NewClientFactory("34adfa4f-cedf-4dc0-ba29-b6d1a69ab345", cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
poller, err := clientFactory.NewContainerAppsClient().BeginCreateOrUpdate(ctx, "rg", "testcontainerApp0", armappcontainers.ContainerApp{
ExtendedLocation: &armappcontainers.ExtendedLocation{
Name: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.ExtendedLocation/customLocations/testcustomlocation"),
Type: to.Ptr(armappcontainers.ExtendedLocationTypesCustomLocation),
},
Location: to.Ptr("East US"),
Properties: &armappcontainers.ContainerAppProperties{
Configuration: &armappcontainers.Configuration{
Dapr: &armappcontainers.Dapr{
AppPort: to.Ptr[int32](3000),
AppProtocol: to.Ptr(armappcontainers.AppProtocolHTTP),
EnableAPILogging: to.Ptr(true),
Enabled: to.Ptr(true),
HTTPMaxRequestSize: to.Ptr[int32](10),
HTTPReadBufferSize: to.Ptr[int32](30),
LogLevel: to.Ptr(armappcontainers.LogLevelDebug),
},
Ingress: &armappcontainers.Ingress{
AdditionalPortMappings: []*armappcontainers.IngressPortMapping{
{
External: to.Ptr(true),
TargetPort: to.Ptr[int32](1234),
},
{
ExposedPort: to.Ptr[int32](3456),
External: to.Ptr(false),
TargetPort: to.Ptr[int32](2345),
},
},
ClientCertificateMode: to.Ptr(armappcontainers.IngressClientCertificateModeAccept),
CorsPolicy: &armappcontainers.CorsPolicy{
AllowCredentials: to.Ptr(true),
AllowedHeaders: []*string{
to.Ptr("HEADER1"),
to.Ptr("HEADER2"),
},
AllowedMethods: []*string{
to.Ptr("GET"),
to.Ptr("POST"),
},
AllowedOrigins: []*string{
to.Ptr("https://a.test.com"),
to.Ptr("https://b.test.com"),
},
ExposeHeaders: []*string{
to.Ptr("HEADER3"),
to.Ptr("HEADER4"),
},
MaxAge: to.Ptr[int32](1234),
},
CustomDomains: []*armappcontainers.CustomDomain{
{
Name: to.Ptr("www.my-name.com"),
BindingType: to.Ptr(armappcontainers.BindingTypeSniEnabled),
CertificateID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube/certificates/my-certificate-for-my-name-dot-com"),
},
{
Name: to.Ptr("www.my-other-name.com"),
BindingType: to.Ptr(armappcontainers.BindingTypeSniEnabled),
CertificateID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube/certificates/my-certificate-for-my-other-name-dot-com"),
},
},
External: to.Ptr(true),
IPSecurityRestrictions: []*armappcontainers.IPSecurityRestrictionRule{
{
Name: to.Ptr("Allow work IP A subnet"),
Description: to.Ptr("Allowing all IP's within the subnet below to access containerapp"),
Action: to.Ptr(armappcontainers.ActionAllow),
IPAddressRange: to.Ptr("192.168.1.1/32"),
},
{
Name: to.Ptr("Allow work IP B subnet"),
Description: to.Ptr("Allowing all IP's within the subnet below to access containerapp"),
Action: to.Ptr(armappcontainers.ActionAllow),
IPAddressRange: to.Ptr("192.168.1.1/8"),
},
},
StickySessions: &armappcontainers.IngressStickySessions{
Affinity: to.Ptr(armappcontainers.AffinitySticky),
},
TargetPort: to.Ptr[int32](3000),
Traffic: []*armappcontainers.TrafficWeight{
{
Label: to.Ptr("production"),
RevisionName: to.Ptr("testcontainerApp0-ab1234"),
},
},
},
MaxInactiveRevisions: to.Ptr[int32](10),
Runtime: &armappcontainers.Runtime{
Java: &armappcontainers.RuntimeJava{
EnableMetrics: to.Ptr(true),
},
},
},
EnvironmentID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube"),
Template: &armappcontainers.Template{
Containers: []*armappcontainers.Container{
{
Name: to.Ptr("testcontainerApp0"),
Image: to.Ptr("repo/testcontainerApp0:v1"),
Probes: []*armappcontainers.ContainerAppProbe{
{
Type: to.Ptr(armappcontainers.TypeLiveness),
HTTPGet: &armappcontainers.ContainerAppProbeHTTPGet{
Path: to.Ptr("/health"),
HTTPHeaders: []*armappcontainers.ContainerAppProbeHTTPGetHTTPHeadersItem{
{
Name: to.Ptr("Custom-Header"),
Value: to.Ptr("Awesome"),
},
},
Port: to.Ptr[int32](8080),
},
InitialDelaySeconds: to.Ptr[int32](3),
PeriodSeconds: to.Ptr[int32](3),
},
},
},
},
InitContainers: []*armappcontainers.InitContainer{
{
Name: to.Ptr("testinitcontainerApp0"),
Args: []*string{
to.Ptr("-c"),
to.Ptr("while true; do echo hello; sleep 10;done"),
},
Command: []*string{
to.Ptr("/bin/sh"),
},
Image: to.Ptr("repo/testcontainerApp0:v4"),
Resources: &armappcontainers.ContainerResources{
CPU: to.Ptr[float64](0.2),
Memory: to.Ptr("100Mi"),
},
},
},
Scale: &armappcontainers.Scale{
CooldownPeriod: to.Ptr[int32](350),
MaxReplicas: to.Ptr[int32](5),
MinReplicas: to.Ptr[int32](1),
PollingInterval: to.Ptr[int32](35),
Rules: []*armappcontainers.ScaleRule{
{
Name: to.Ptr("httpscalingrule"),
Custom: &armappcontainers.CustomScaleRule{
Type: to.Ptr("http"),
Metadata: map[string]*string{
"concurrentRequests": to.Ptr("50"),
},
},
},
},
},
},
},
}, nil)
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
res, err := poller.PollUntilDone(ctx, nil)
if err != nil {
log.Fatalf("failed to poll the result: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armappcontainers.ContainerAppsClientCreateOrUpdateResponse{
// ContainerApp: armappcontainers.ContainerApp{
// Name: to.Ptr("testcontainerApp0"),
// Type: to.Ptr("Microsoft.App/containerApps"),
// ExtendedLocation: &armappcontainers.ExtendedLocation{
// Name: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.ExtendedLocation/customLocations/testcustomlocation"),
// Type: to.Ptr(armappcontainers.ExtendedLocationTypesCustomLocation),
// },
// ID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/containerApps/testcontainerApp0"),
// Location: to.Ptr("East US"),
// Properties: &armappcontainers.ContainerAppProperties{
// Configuration: &armappcontainers.Configuration{
// Dapr: &armappcontainers.Dapr{
// AppPort: to.Ptr[int32](3000),
// AppProtocol: to.Ptr(armappcontainers.AppProtocolHTTP),
// Enabled: to.Ptr(true),
// HTTPReadBufferSize: to.Ptr[int32](30),
// },
// Ingress: &armappcontainers.Ingress{
// CustomDomains: []*armappcontainers.CustomDomain{
// {
// Name: to.Ptr("www.my-name.com"),
// BindingType: to.Ptr(armappcontainers.BindingTypeSniEnabled),
// CertificateID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube/certificates/my-certificate-for-my-name-dot-com"),
// },
// {
// Name: to.Ptr("www.my-other-name.com"),
// BindingType: to.Ptr(armappcontainers.BindingTypeSniEnabled),
// CertificateID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube/certificates/my-certificate-for-my-other-name-dot-com"),
// },
// },
// External: to.Ptr(true),
// Fqdn: to.Ptr("testcontainerApp0.demokube-t24clv0g.eastus.containerApps.k4apps.io"),
// IPSecurityRestrictions: []*armappcontainers.IPSecurityRestrictionRule{
// {
// Name: to.Ptr("Allow work IP A subnet"),
// Description: to.Ptr("Allowing all IP's within the subnet below to access containerapp"),
// Action: to.Ptr(armappcontainers.ActionAllow),
// IPAddressRange: to.Ptr("192.168.1.1/32"),
// },
// {
// Name: to.Ptr("Allow work IP B subnet"),
// Description: to.Ptr("Allowing all IP's within the subnet below to access containerapp"),
// Action: to.Ptr(armappcontainers.ActionAllow),
// IPAddressRange: to.Ptr("192.168.1.1/8"),
// },
// },
// StickySessions: &armappcontainers.IngressStickySessions{
// Affinity: to.Ptr(armappcontainers.AffinitySticky),
// },
// TargetPort: to.Ptr[int32](3000),
// Traffic: []*armappcontainers.TrafficWeight{
// {
// RevisionName: to.Ptr("testcontainerApp0-ab1234"),
// },
// {
// Label: to.Ptr("staging"),
// RevisionName: to.Ptr("testcontainerApp0-ab4321"),
// },
// },
// Transport: to.Ptr(armappcontainers.IngressTransportMethodAuto),
// },
// Runtime: &armappcontainers.Runtime{
// Java: &armappcontainers.RuntimeJava{
// EnableMetrics: to.Ptr(true),
// },
// },
// },
// EnvironmentID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube"),
// EventStreamEndpoint: to.Ptr("testEndpoint"),
// LatestReadyRevisionName: to.Ptr("testcontainerApp0-pjxhsye"),
// LatestRevisionFqdn: to.Ptr("testcontainerApp0-pjxhsye.demokube-t24clv0g.eastus.containerApps.k4apps.io"),
// ProvisioningState: to.Ptr(armappcontainers.ContainerAppProvisioningStateSucceeded),
// RunningStatus: to.Ptr(armappcontainers.ContainerAppRunningStatusRunning),
// Template: &armappcontainers.Template{
// Containers: []*armappcontainers.Container{
// {
// Name: to.Ptr("testcontainerApp0"),
// Image: to.Ptr("repo/testcontainerApp0:v4"),
// Probes: []*armappcontainers.ContainerAppProbe{
// {
// Type: to.Ptr(armappcontainers.TypeLiveness),
// HTTPGet: &armappcontainers.ContainerAppProbeHTTPGet{
// Path: to.Ptr("/health"),
// HTTPHeaders: []*armappcontainers.ContainerAppProbeHTTPGetHTTPHeadersItem{
// {
// Name: to.Ptr("Custom-Header"),
// Value: to.Ptr("Awesome"),
// },
// },
// Port: to.Ptr[int32](8080),
// },
// InitialDelaySeconds: to.Ptr[int32](3),
// PeriodSeconds: to.Ptr[int32](3),
// },
// },
// Resources: &armappcontainers.ContainerResources{
// CPU: to.Ptr[float64](0.2),
// Memory: to.Ptr("100Mi"),
// },
// },
// },
// InitContainers: []*armappcontainers.InitContainer{
// {
// Name: to.Ptr("testinitcontainerApp0"),
// Args: []*string{
// to.Ptr("-c"),
// to.Ptr("while true; do echo hello; sleep 10;done"),
// },
// Command: []*string{
// to.Ptr("/bin/sh"),
// },
// Image: to.Ptr("repo/testcontainerApp0:v4"),
// Resources: &armappcontainers.ContainerResources{
// CPU: to.Ptr[float64](0.2),
// Memory: to.Ptr("100Mi"),
// },
// },
// },
// Scale: &armappcontainers.Scale{
// CooldownPeriod: to.Ptr[int32](350),
// MaxReplicas: to.Ptr[int32](5),
// MinReplicas: to.Ptr[int32](1),
// PollingInterval: to.Ptr[int32](35),
// Rules: []*armappcontainers.ScaleRule{
// {
// Name: to.Ptr("httpscalingrule"),
// HTTP: &armappcontainers.HTTPScaleRule{
// Metadata: map[string]*string{
// "concurrentRequests": to.Ptr("50"),
// },
// },
// },
// },
// },
// },
// },
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
const { ContainerAppsAPIClient } = require("@azure/arm-appcontainers");
const { DefaultAzureCredential } = require("@azure/identity");
/**
* This sample demonstrates how to create or update a Container App.
*
* @summary create or update a Container App.
* x-ms-original-file: 2026-07-01/ContainerApps_CreateOrUpdate_ConnectedEnvironment.json
*/
async function createOrUpdateAppOnAConnectedEnvironment() {
const credential = new DefaultAzureCredential();
const subscriptionId = "34adfa4f-cedf-4dc0-ba29-b6d1a69ab345";
const client = new ContainerAppsAPIClient(credential, subscriptionId);
const result = await client.containerApps.createOrUpdate("rg", "testcontainerApp0", {
extendedLocation: {
name: "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.ExtendedLocation/customLocations/testcustomlocation",
type: "CustomLocation",
},
location: "East US",
configuration: {
dapr: {
appPort: 3000,
appProtocol: "http",
enableApiLogging: true,
enabled: true,
httpMaxRequestSize: 10,
httpReadBufferSize: 30,
logLevel: "debug",
},
ingress: {
additionalPortMappings: [
{ external: true, targetPort: 1234 },
{ exposedPort: 3456, external: false, targetPort: 2345 },
],
clientCertificateMode: "accept",
corsPolicy: {
allowCredentials: true,
allowedHeaders: ["HEADER1", "HEADER2"],
allowedMethods: ["GET", "POST"],
allowedOrigins: ["https://a.test.com", "https://b.test.com"],
exposeHeaders: ["HEADER3", "HEADER4"],
maxAge: 1234,
},
customDomains: [
{
name: "www.my-name.com",
bindingType: "SniEnabled",
certificateId:
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube/certificates/my-certificate-for-my-name-dot-com",
},
{
name: "www.my-other-name.com",
bindingType: "SniEnabled",
certificateId:
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube/certificates/my-certificate-for-my-other-name-dot-com",
},
],
external: true,
ipSecurityRestrictions: [
{
name: "Allow work IP A subnet",
description: "Allowing all IP's within the subnet below to access containerapp",
action: "Allow",
ipAddressRange: "192.168.1.1/32",
},
{
name: "Allow work IP B subnet",
description: "Allowing all IP's within the subnet below to access containerapp",
action: "Allow",
ipAddressRange: "192.168.1.1/8",
},
],
stickySessions: { affinity: "sticky" },
targetPort: 3000,
traffic: [{ label: "production", revisionName: "testcontainerApp0-ab1234" }],
},
maxInactiveRevisions: 10,
runtime: { java: { enableMetrics: true } },
},
environmentId:
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube",
template: {
containers: [
{
name: "testcontainerApp0",
image: "repo/testcontainerApp0:v1",
probes: [
{
type: "Liveness",
httpGet: {
path: "/health",
httpHeaders: [{ name: "Custom-Header", value: "Awesome" }],
port: 8080,
},
initialDelaySeconds: 3,
periodSeconds: 3,
},
],
},
],
initContainers: [
{
name: "testinitcontainerApp0",
args: ["-c", "while true; do echo hello; sleep 10;done"],
command: ["/bin/sh"],
image: "repo/testcontainerApp0:v4",
resources: { cpu: 0.2, memory: "100Mi" },
},
],
scale: {
cooldownPeriod: 350,
maxReplicas: 5,
minReplicas: 1,
pollingInterval: 35,
rules: [
{
name: "httpscalingrule",
custom: { type: "http", metadata: { concurrentRequests: "50" } },
},
],
},
},
});
console.log(result);
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Sample response
{
"name": "testcontainerApp0",
"type": "Microsoft.App/containerApps",
"extendedLocation": {
"name": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.ExtendedLocation/customLocations/testcustomlocation",
"type": "CustomLocation"
},
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/containerApps/testcontainerApp0",
"location": "East US",
"properties": {
"configuration": {
"dapr": {
"appPort": 3000,
"appProtocol": "http",
"enabled": true,
"httpReadBufferSize": 30
},
"ingress": {
"customDomains": [
{
"name": "www.my-name.com",
"bindingType": "SniEnabled",
"certificateId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube/certificates/my-certificate-for-my-name-dot-com"
},
{
"name": "www.my-other-name.com",
"bindingType": "SniEnabled",
"certificateId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube/certificates/my-certificate-for-my-other-name-dot-com"
}
],
"external": true,
"fqdn": "testcontainerApp0.demokube-t24clv0g.eastus.containerApps.k4apps.io",
"ipSecurityRestrictions": [
{
"name": "Allow work IP A subnet",
"description": "Allowing all IP's within the subnet below to access containerapp",
"action": "Allow",
"ipAddressRange": "192.168.1.1/32"
},
{
"name": "Allow work IP B subnet",
"description": "Allowing all IP's within the subnet below to access containerapp",
"action": "Allow",
"ipAddressRange": "192.168.1.1/8"
}
],
"stickySessions": {
"affinity": "sticky"
},
"targetPort": 3000,
"traffic": [
{
"revisionName": "testcontainerApp0-ab1234"
},
{
"label": "staging",
"revisionName": "testcontainerApp0-ab4321"
}
],
"transport": "auto"
},
"runtime": {
"java": {
"enableMetrics": true
}
}
},
"environmentId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube",
"eventStreamEndpoint": "testEndpoint",
"latestReadyRevisionName": "testcontainerApp0-pjxhsye",
"latestRevisionFqdn": "testcontainerApp0-pjxhsye.demokube-t24clv0g.eastus.containerApps.k4apps.io",
"provisioningState": "Succeeded",
"runningStatus": "Running",
"template": {
"containers": [
{
"name": "testcontainerApp0",
"image": "repo/testcontainerApp0:v4",
"probes": [
{
"type": "Liveness",
"httpGet": {
"path": "/health",
"httpHeaders": [
{
"name": "Custom-Header",
"value": "Awesome"
}
],
"port": 8080
},
"initialDelaySeconds": 3,
"periodSeconds": 3
}
],
"resources": {
"cpu": 0.2,
"memory": "100Mi"
}
}
],
"initContainers": [
{
"name": "testinitcontainerApp0",
"args": [
"-c",
"while true; do echo hello; sleep 10;done"
],
"command": [
"/bin/sh"
],
"image": "repo/testcontainerApp0:v4",
"resources": {
"cpu": 0.2,
"memory": "100Mi"
}
}
],
"scale": {
"cooldownPeriod": 350,
"maxReplicas": 5,
"minReplicas": 1,
"pollingInterval": 35,
"rules": [
{
"name": "httpscalingrule",
"http": {
"metadata": {
"concurrentRequests": "50"
}
}
}
]
}
}
}
}
{
"name": "testcontainerApp0",
"type": "Microsoft.App/containerApps",
"extendedLocation": {
"name": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.ExtendedLocation/customLocations/testcustomlocation",
"type": "CustomLocation"
},
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/containerApps/testcontainerApp0",
"location": "East US",
"properties": {
"configuration": {
"dapr": {
"appPort": 3000,
"appProtocol": "http",
"enabled": true,
"httpReadBufferSize": 30
},
"ingress": {
"external": true,
"fqdn": "testcontainerApp0.demokube-t24clv0g.eastus.containerApps.k4apps.io",
"targetPort": 3000,
"traffic": [
{
"revisionName": "testcontainerApp0-ab1234"
},
{
"label": "staging",
"revisionName": "testcontainerApp0-ab4321"
}
],
"transport": "auto"
},
"runtime": {
"java": {
"enableMetrics": true
}
}
},
"environmentId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/connectedEnvironments/demokube",
"eventStreamEndpoint": "testEndpoint",
"latestRevisionFqdn": "testcontainerApp0-pjxhsye.demokube-t24clv0g.eastus.containerApps.k4apps.io",
"provisioningState": "InProgress",
"runningStatus": "Progressing",
"template": {
"containers": [
{
"name": "testcontainerApp0",
"image": "repo/testcontainerApp0:v4",
"probes": [
{
"type": "Liveness",
"httpGet": {
"path": "/health",
"httpHeaders": [
{
"name": "Custom-Header",
"value": "Awesome"
}
],
"port": 8080
},
"initialDelaySeconds": 3,
"periodSeconds": 3
}
],
"resources": {
"cpu": 0.2,
"memory": "100Mi"
}
}
],
"initContainers": [
{
"name": "testinitcontainerApp0",
"args": [
"-c",
"while true; do echo hello; sleep 10;done"
],
"command": [
"/bin/sh"
],
"image": "repo/testcontainerApp0:v4",
"resources": {
"cpu": 0.2,
"memory": "100Mi"
}
}
],
"scale": {
"cooldownPeriod": 350,
"maxReplicas": 5,
"minReplicas": 1,
"pollingInterval": 35,
"rules": [
{
"name": "httpscalingrule",
"http": {
"metadata": {
"concurrentRequests": "50"
}
}
}
]
}
}
}
}
Create or Update Container App
Sample request
PUT https://management.azure.com/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/containerApps/testcontainerApp0?api-version=2026-07-01
{
"identity": {
"type": "SystemAssigned,UserAssigned",
"userAssignedIdentities": {
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity": {}
}
},
"location": "East US",
"properties": {
"configuration": {
"dapr": {
"appHealth": {
"path": "/health",
"enabled": true,
"probeIntervalSeconds": 3,
"probeTimeoutMilliseconds": 1000,
"threshold": 3
},
"appPort": 3000,
"appProtocol": "http",
"enableApiLogging": true,
"enabled": true,
"httpMaxRequestSize": 10,
"httpReadBufferSize": 30,
"logLevel": "debug",
"maxConcurrency": 10
},
"identitySettings": [
{
"identity": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity",
"lifecycle": "All"
},
{
"identity": "system",
"lifecycle": "Init"
}
],
"ingress": {
"additionalPortMappings": [
{
"external": true,
"targetPort": 1234
},
{
"exposedPort": 3456,
"external": false,
"targetPort": 2345
}
],
"clientCertificateMode": "accept",
"corsPolicy": {
"allowCredentials": true,
"allowedHeaders": [
"HEADER1",
"HEADER2"
],
"allowedMethods": [
"GET",
"POST"
],
"allowedOrigins": [
"https://a.test.com",
"https://b.test.com"
],
"exposeHeaders": [
"HEADER3",
"HEADER4"
],
"maxAge": 1234
},
"customDomains": [
{
"name": "www.my-name.com",
"bindingType": "SniEnabled",
"certificateId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube/certificates/my-certificate-for-my-name-dot-com"
},
{
"name": "www.my-other-name.com",
"bindingType": "SniEnabled",
"certificateId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube/certificates/my-certificate-for-my-other-name-dot-com"
}
],
"external": true,
"ipSecurityRestrictions": [
{
"name": "Allow work IP A subnet",
"description": "Allowing all IP's within the subnet below to access containerapp",
"action": "Allow",
"ipAddressRange": "192.168.1.1/32"
},
{
"name": "Allow work IP B subnet",
"description": "Allowing all IP's within the subnet below to access containerapp",
"action": "Allow",
"ipAddressRange": "192.168.1.1/8"
}
],
"stickySessions": {
"affinity": "sticky"
},
"targetPort": 3000,
"traffic": [
{
"label": "production",
"revisionName": "testcontainerApp0-ab1234"
}
]
},
"maxInactiveRevisions": 10,
"runtime": {
"java": {
"enableMetrics": true
}
},
"service": {
"type": "redis"
}
},
"environmentId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube",
"template": {
"containers": [
{
"name": "testcontainerApp0",
"image": "repo/testcontainerApp0:v1",
"probes": [
{
"type": "Liveness",
"httpGet": {
"path": "/health",
"httpHeaders": [
{
"name": "Custom-Header",
"value": "Awesome"
}
],
"port": 8080
},
"initialDelaySeconds": 3,
"periodSeconds": 3
}
],
"volumeMounts": [
{
"mountPath": "/mnt/path1",
"subPath": "subPath1",
"volumeName": "azurefile"
},
{
"mountPath": "/mnt/path2",
"subPath": "subPath2",
"volumeName": "nfsazurefile"
}
]
}
],
"initContainers": [
{
"name": "testinitcontainerApp0",
"args": [
"-c",
"while true; do echo hello; sleep 10;done"
],
"command": [
"/bin/sh"
],
"image": "repo/testcontainerApp0:v4",
"resources": {
"cpu": 0.2,
"memory": "100Mi"
}
}
],
"scale": {
"cooldownPeriod": 350,
"maxReplicas": 5,
"minReplicas": 1,
"pollingInterval": 35,
"rules": [
{
"name": "httpscalingrule",
"custom": {
"type": "http",
"metadata": {
"concurrentRequests": "50"
}
}
},
{
"name": "servicebus",
"custom": {
"type": "azure-servicebus",
"identity": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity",
"metadata": {
"messageCount": "5",
"namespace": "mynamespace",
"queueName": "myqueue"
}
}
},
{
"name": "azure-queue",
"azureQueue": {
"accountName": "account1",
"identity": "system",
"queueLength": 1,
"queueName": "queue1"
}
}
]
},
"serviceBinds": [
{
"name": "redisService",
"serviceId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/containerApps/redisService"
}
],
"volumes": [
{
"name": "azurefile",
"storageName": "storage",
"storageType": "AzureFile"
},
{
"name": "nfsazurefile",
"storageName": "nfsStorage",
"storageType": "NfsAzureFile"
}
]
},
"workloadProfileName": "My-GP-01"
}
}
import com.azure.resourcemanager.appcontainers.models.Action;
import com.azure.resourcemanager.appcontainers.models.Affinity;
import com.azure.resourcemanager.appcontainers.models.AppProtocol;
import com.azure.resourcemanager.appcontainers.models.BindingType;
import com.azure.resourcemanager.appcontainers.models.Configuration;
import com.azure.resourcemanager.appcontainers.models.Container;
import com.azure.resourcemanager.appcontainers.models.ContainerAppProbe;
import com.azure.resourcemanager.appcontainers.models.ContainerAppProbeHttpGet;
import com.azure.resourcemanager.appcontainers.models.ContainerAppProbeHttpGetHttpHeadersItem;
import com.azure.resourcemanager.appcontainers.models.ContainerResources;
import com.azure.resourcemanager.appcontainers.models.CorsPolicy;
import com.azure.resourcemanager.appcontainers.models.CustomDomain;
import com.azure.resourcemanager.appcontainers.models.CustomScaleRule;
import com.azure.resourcemanager.appcontainers.models.Dapr;
import com.azure.resourcemanager.appcontainers.models.DaprAppHealth;
import com.azure.resourcemanager.appcontainers.models.IdentitySettings;
import com.azure.resourcemanager.appcontainers.models.IdentitySettingsLifeCycle;
import com.azure.resourcemanager.appcontainers.models.Ingress;
import com.azure.resourcemanager.appcontainers.models.IngressClientCertificateMode;
import com.azure.resourcemanager.appcontainers.models.IngressPortMapping;
import com.azure.resourcemanager.appcontainers.models.IngressStickySessions;
import com.azure.resourcemanager.appcontainers.models.InitContainer;
import com.azure.resourcemanager.appcontainers.models.IpSecurityRestrictionRule;
import com.azure.resourcemanager.appcontainers.models.LogLevel;
import com.azure.resourcemanager.appcontainers.models.ManagedServiceIdentity;
import com.azure.resourcemanager.appcontainers.models.ManagedServiceIdentityType;
import com.azure.resourcemanager.appcontainers.models.QueueScaleRule;
import com.azure.resourcemanager.appcontainers.models.Runtime;
import com.azure.resourcemanager.appcontainers.models.RuntimeJava;
import com.azure.resourcemanager.appcontainers.models.Scale;
import com.azure.resourcemanager.appcontainers.models.ScaleRule;
import com.azure.resourcemanager.appcontainers.models.Service;
import com.azure.resourcemanager.appcontainers.models.ServiceBind;
import com.azure.resourcemanager.appcontainers.models.StorageType;
import com.azure.resourcemanager.appcontainers.models.Template;
import com.azure.resourcemanager.appcontainers.models.TrafficWeight;
import com.azure.resourcemanager.appcontainers.models.Type;
import com.azure.resourcemanager.appcontainers.models.UserAssignedIdentity;
import com.azure.resourcemanager.appcontainers.models.Volume;
import com.azure.resourcemanager.appcontainers.models.VolumeMount;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
/**
* Samples for ContainerApps CreateOrUpdate.
*/
public final class Main {
/*
* x-ms-original-file: 2026-07-01/ContainerApps_CreateOrUpdate.json
*/
/**
* Sample code: Create or Update Container App.
*
* @param manager Entry point to ContainerAppsApiManager.
*/
public static void
createOrUpdateContainerApp(com.azure.resourcemanager.appcontainers.ContainerAppsApiManager manager) {
manager.containerApps().define("testcontainerApp0").withRegion("East US").withExistingResourceGroup("rg")
.withIdentity(new ManagedServiceIdentity()
.withType(ManagedServiceIdentityType.SYSTEM_ASSIGNED_USER_ASSIGNED)
.withUserAssignedIdentities(mapOf(
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity",
new UserAssignedIdentity())))
.withEnvironmentId(
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube")
.withWorkloadProfileName("My-GP-01")
.withConfiguration(new Configuration().withIngress(new Ingress().withExternal(true).withTargetPort(3000)
.withTraffic(Arrays
.asList(new TrafficWeight().withRevisionName("testcontainerApp0-ab1234").withLabel("production")))
.withCustomDomains(Arrays.asList(new CustomDomain().withName("www.my-name.com")
.withBindingType(BindingType.SNI_ENABLED).withCertificateId(
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube/certificates/my-certificate-for-my-name-dot-com"),
new CustomDomain().withName("www.my-other-name.com").withBindingType(BindingType.SNI_ENABLED)
.withCertificateId(
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube/certificates/my-certificate-for-my-other-name-dot-com")))
.withIpSecurityRestrictions(Arrays.asList(
new IpSecurityRestrictionRule().withName("Allow work IP A subnet")
.withDescription("Allowing all IP's within the subnet below to access containerapp")
.withIpAddressRange("192.168.1.1/32").withAction(Action.ALLOW),
new IpSecurityRestrictionRule().withName("Allow work IP B subnet")
.withDescription("Allowing all IP's within the subnet below to access containerapp")
.withIpAddressRange("192.168.1.1/8").withAction(Action.ALLOW)))
.withStickySessions(new IngressStickySessions().withAffinity(Affinity.STICKY))
.withClientCertificateMode(IngressClientCertificateMode.ACCEPT)
.withCorsPolicy(new CorsPolicy()
.withAllowedOrigins(Arrays.asList("https://a.test.com", "https://b.test.com"))
.withAllowedMethods(Arrays.asList("GET", "POST"))
.withAllowedHeaders(Arrays.asList("HEADER1", "HEADER2"))
.withExposeHeaders(Arrays.asList("HEADER3", "HEADER4")).withMaxAge(1234).withAllowCredentials(true))
.withAdditionalPortMappings(
Arrays.asList(new IngressPortMapping().withExternal(true).withTargetPort(1234),
new IngressPortMapping().withExternal(false).withTargetPort(2345).withExposedPort(3456))))
.withDapr(new Dapr().withEnabled(true).withAppProtocol(AppProtocol.HTTP).withAppPort(3000)
.withHttpReadBufferSize(30).withHttpMaxRequestSize(10).withLogLevel(LogLevel.DEBUG)
.withEnableApiLogging(true)
.withAppHealth(new DaprAppHealth().withEnabled(true).withPath("/health").withProbeIntervalSeconds(3)
.withProbeTimeoutMilliseconds(1000).withThreshold(3))
.withMaxConcurrency(10))
.withRuntime(new Runtime().withJava(new RuntimeJava().withEnableMetrics(true)))
.withMaxInactiveRevisions(10).withService(new Service().withType("redis"))
.withIdentitySettings(Arrays.asList(new IdentitySettings().withIdentity(
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity")
.withLifecycle(IdentitySettingsLifeCycle.ALL),
new IdentitySettings().withIdentity("system").withLifecycle(IdentitySettingsLifeCycle.INIT))))
.withTemplate(new Template()
.withInitContainers(Arrays.asList(new InitContainer().withImage("repo/testcontainerApp0:v4")
.withName("testinitcontainerApp0").withCommand(Arrays.asList("/bin/sh"))
.withArgs(Arrays.asList("-c", "while true; do echo hello; sleep 10;done"))
.withResources(new ContainerResources().withCpu(0.2D).withMemory("100Mi"))))
.withContainers(
Arrays.asList(new Container().withImage("repo/testcontainerApp0:v1").withName("testcontainerApp0")
.withVolumeMounts(Arrays.asList(
new VolumeMount().withVolumeName("azurefile").withMountPath("/mnt/path1")
.withSubPath("subPath1"),
new VolumeMount().withVolumeName("nfsazurefile").withMountPath("/mnt/path2")
.withSubPath("subPath2")))
.withProbes(Arrays.asList(new ContainerAppProbe()
.withHttpGet(new ContainerAppProbeHttpGet()
.withHttpHeaders(Arrays.asList(new ContainerAppProbeHttpGetHttpHeadersItem()
.withName("Custom-Header").withValue("Awesome")))
.withPath("/health").withPort(8080))
.withInitialDelaySeconds(3).withPeriodSeconds(3).withType(Type.LIVENESS)))))
.withScale(new Scale().withMinReplicas(1).withMaxReplicas(5).withCooldownPeriod(350)
.withPollingInterval(35)
.withRules(Arrays.asList(
new ScaleRule().withName("httpscalingrule").withCustom(
new CustomScaleRule().withType("http").withMetadata(mapOf("concurrentRequests", "50"))),
new ScaleRule().withName("servicebus").withCustom(new CustomScaleRule()
.withType("azure-servicebus")
.withMetadata(
mapOf("messageCount", "5", "namespace", "mynamespace", "queueName", "myqueue"))
.withIdentity(
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity")),
new ScaleRule().withName("azure-queue")
.withAzureQueue(new QueueScaleRule().withAccountName("account1").withQueueName("queue1")
.withQueueLength(1).withIdentity("system")))))
.withVolumes(Arrays.asList(
new Volume().withName("azurefile").withStorageType(StorageType.AZURE_FILE)
.withStorageName("storage"),
new Volume().withName("nfsazurefile").withStorageType(StorageType.NFS_AZURE_FILE)
.withStorageName("nfsStorage")))
.withServiceBinds(Arrays.asList(new ServiceBind().withServiceId(
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/containerApps/redisService")
.withName("redisService"))))
.create();
}
// Use "Map.of" if available
@SuppressWarnings("unchecked")
private static <T> Map<String, T> mapOf(Object... inputs) {
Map<String, T> map = new HashMap<>();
for (int i = 0; i < inputs.length; i += 2) {
String key = (String) inputs[i];
T value = (T) inputs[i + 1];
map.put(key, value);
}
return map;
}
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
from azure.identity import DefaultAzureCredential
from azure.mgmt.appcontainers import ContainerAppsAPIClient
"""
# PREREQUISITES
pip install azure-identity
pip install azure-mgmt-appcontainers
# USAGE
python container_apps_create_or_update.py
Before run the sample, please set the values of the client ID, tenant ID and client secret
of the AAD application as environment variables: AZURE_CLIENT_ID, AZURE_TENANT_ID,
AZURE_CLIENT_SECRET. For more info about how to get the value, please see:
https://docs.microsoft.com/azure/active-directory/develop/howto-create-service-principal-portal
"""
def main():
client = ContainerAppsAPIClient(
credential=DefaultAzureCredential(),
subscription_id="SUBSCRIPTION_ID",
)
response = client.container_apps.begin_create_or_update(
resource_group_name="rg",
container_app_name="testcontainerApp0",
container_app_envelope={
"identity": {
"type": "SystemAssigned,UserAssigned",
"userAssignedIdentities": {
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity": {}
},
},
"location": "East US",
"properties": {
"configuration": {
"dapr": {
"appHealth": {
"enabled": True,
"path": "/health",
"probeIntervalSeconds": 3,
"probeTimeoutMilliseconds": 1000,
"threshold": 3,
},
"appPort": 3000,
"appProtocol": "http",
"enableApiLogging": True,
"enabled": True,
"httpMaxRequestSize": 10,
"httpReadBufferSize": 30,
"logLevel": "debug",
"maxConcurrency": 10,
},
"identitySettings": [
{
"identity": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity",
"lifecycle": "All",
},
{"identity": "system", "lifecycle": "Init"},
],
"ingress": {
"additionalPortMappings": [
{"external": True, "targetPort": 1234},
{"exposedPort": 3456, "external": False, "targetPort": 2345},
],
"clientCertificateMode": "accept",
"corsPolicy": {
"allowCredentials": True,
"allowedHeaders": ["HEADER1", "HEADER2"],
"allowedMethods": ["GET", "POST"],
"allowedOrigins": ["https://a.test.com", "https://b.test.com"],
"exposeHeaders": ["HEADER3", "HEADER4"],
"maxAge": 1234,
},
"customDomains": [
{
"bindingType": "SniEnabled",
"certificateId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube/certificates/my-certificate-for-my-name-dot-com",
"name": "www.my-name.com",
},
{
"bindingType": "SniEnabled",
"certificateId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube/certificates/my-certificate-for-my-other-name-dot-com",
"name": "www.my-other-name.com",
},
],
"external": True,
"ipSecurityRestrictions": [
{
"action": "Allow",
"description": "Allowing all IP's within the subnet below to access containerapp",
"ipAddressRange": "192.168.1.1/32",
"name": "Allow work IP A subnet",
},
{
"action": "Allow",
"description": "Allowing all IP's within the subnet below to access containerapp",
"ipAddressRange": "192.168.1.1/8",
"name": "Allow work IP B subnet",
},
],
"stickySessions": {"affinity": "sticky"},
"targetPort": 3000,
"traffic": [{"label": "production", "revisionName": "testcontainerApp0-ab1234"}],
},
"maxInactiveRevisions": 10,
"runtime": {"java": {"enableMetrics": True}},
"service": {"type": "redis"},
},
"environmentId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube",
"template": {
"containers": [
{
"image": "repo/testcontainerApp0:v1",
"name": "testcontainerApp0",
"probes": [
{
"httpGet": {
"httpHeaders": [{"name": "Custom-Header", "value": "Awesome"}],
"path": "/health",
"port": 8080,
},
"initialDelaySeconds": 3,
"periodSeconds": 3,
"type": "Liveness",
}
],
"volumeMounts": [
{"mountPath": "/mnt/path1", "subPath": "subPath1", "volumeName": "azurefile"},
{"mountPath": "/mnt/path2", "subPath": "subPath2", "volumeName": "nfsazurefile"},
],
}
],
"initContainers": [
{
"args": ["-c", "while true; do echo hello; sleep 10;done"],
"command": ["/bin/sh"],
"image": "repo/testcontainerApp0:v4",
"name": "testinitcontainerApp0",
"resources": {"cpu": 0.2, "memory": "100Mi"},
}
],
"scale": {
"cooldownPeriod": 350,
"maxReplicas": 5,
"minReplicas": 1,
"pollingInterval": 35,
"rules": [
{
"custom": {"metadata": {"concurrentRequests": "50"}, "type": "http"},
"name": "httpscalingrule",
},
{
"custom": {
"identity": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity",
"metadata": {
"messageCount": "5",
"namespace": "mynamespace",
"queueName": "myqueue",
},
"type": "azure-servicebus",
},
"name": "servicebus",
},
{
"azureQueue": {
"accountName": "account1",
"identity": "system",
"queueLength": 1,
"queueName": "queue1",
},
"name": "azure-queue",
},
],
},
"serviceBinds": [
{
"name": "redisService",
"serviceId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/containerApps/redisService",
}
],
"volumes": [
{"name": "azurefile", "storageName": "storage", "storageType": "AzureFile"},
{"name": "nfsazurefile", "storageName": "nfsStorage", "storageType": "NfsAzureFile"},
],
},
"workloadProfileName": "My-GP-01",
},
},
).result()
print(response)
# x-ms-original-file: 2026-07-01/ContainerApps_CreateOrUpdate.json
if __name__ == "__main__":
main()
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
package armappcontainers_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/appcontainers/armappcontainers/v5"
)
// Generated from example definition: 2026-07-01/ContainerApps_CreateOrUpdate.json
func ExampleContainerAppsClient_BeginCreateOrUpdate_createOrUpdateContainerApp() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armappcontainers.NewClientFactory("34adfa4f-cedf-4dc0-ba29-b6d1a69ab345", cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
poller, err := clientFactory.NewContainerAppsClient().BeginCreateOrUpdate(ctx, "rg", "testcontainerApp0", armappcontainers.ContainerApp{
Identity: &armappcontainers.ManagedServiceIdentity{
Type: to.Ptr(armappcontainers.ManagedServiceIdentityTypeSystemAssignedUserAssigned),
UserAssignedIdentities: map[string]*armappcontainers.UserAssignedIdentity{
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity": {},
},
},
Location: to.Ptr("East US"),
Properties: &armappcontainers.ContainerAppProperties{
Configuration: &armappcontainers.Configuration{
Dapr: &armappcontainers.Dapr{
AppHealth: &armappcontainers.DaprAppHealth{
Path: to.Ptr("/health"),
Enabled: to.Ptr(true),
ProbeIntervalSeconds: to.Ptr[int32](3),
ProbeTimeoutMilliseconds: to.Ptr[int32](1000),
Threshold: to.Ptr[int32](3),
},
AppPort: to.Ptr[int32](3000),
AppProtocol: to.Ptr(armappcontainers.AppProtocolHTTP),
EnableAPILogging: to.Ptr(true),
Enabled: to.Ptr(true),
HTTPMaxRequestSize: to.Ptr[int32](10),
HTTPReadBufferSize: to.Ptr[int32](30),
LogLevel: to.Ptr(armappcontainers.LogLevelDebug),
MaxConcurrency: to.Ptr[int32](10),
},
IdentitySettings: []*armappcontainers.IdentitySettings{
{
Identity: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity"),
Lifecycle: to.Ptr(armappcontainers.IdentitySettingsLifeCycleAll),
},
{
Identity: to.Ptr("system"),
Lifecycle: to.Ptr(armappcontainers.IdentitySettingsLifeCycleInit),
},
},
Ingress: &armappcontainers.Ingress{
AdditionalPortMappings: []*armappcontainers.IngressPortMapping{
{
External: to.Ptr(true),
TargetPort: to.Ptr[int32](1234),
},
{
ExposedPort: to.Ptr[int32](3456),
External: to.Ptr(false),
TargetPort: to.Ptr[int32](2345),
},
},
ClientCertificateMode: to.Ptr(armappcontainers.IngressClientCertificateModeAccept),
CorsPolicy: &armappcontainers.CorsPolicy{
AllowCredentials: to.Ptr(true),
AllowedHeaders: []*string{
to.Ptr("HEADER1"),
to.Ptr("HEADER2"),
},
AllowedMethods: []*string{
to.Ptr("GET"),
to.Ptr("POST"),
},
AllowedOrigins: []*string{
to.Ptr("https://a.test.com"),
to.Ptr("https://b.test.com"),
},
ExposeHeaders: []*string{
to.Ptr("HEADER3"),
to.Ptr("HEADER4"),
},
MaxAge: to.Ptr[int32](1234),
},
CustomDomains: []*armappcontainers.CustomDomain{
{
Name: to.Ptr("www.my-name.com"),
BindingType: to.Ptr(armappcontainers.BindingTypeSniEnabled),
CertificateID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube/certificates/my-certificate-for-my-name-dot-com"),
},
{
Name: to.Ptr("www.my-other-name.com"),
BindingType: to.Ptr(armappcontainers.BindingTypeSniEnabled),
CertificateID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube/certificates/my-certificate-for-my-other-name-dot-com"),
},
},
External: to.Ptr(true),
IPSecurityRestrictions: []*armappcontainers.IPSecurityRestrictionRule{
{
Name: to.Ptr("Allow work IP A subnet"),
Description: to.Ptr("Allowing all IP's within the subnet below to access containerapp"),
Action: to.Ptr(armappcontainers.ActionAllow),
IPAddressRange: to.Ptr("192.168.1.1/32"),
},
{
Name: to.Ptr("Allow work IP B subnet"),
Description: to.Ptr("Allowing all IP's within the subnet below to access containerapp"),
Action: to.Ptr(armappcontainers.ActionAllow),
IPAddressRange: to.Ptr("192.168.1.1/8"),
},
},
StickySessions: &armappcontainers.IngressStickySessions{
Affinity: to.Ptr(armappcontainers.AffinitySticky),
},
TargetPort: to.Ptr[int32](3000),
Traffic: []*armappcontainers.TrafficWeight{
{
Label: to.Ptr("production"),
RevisionName: to.Ptr("testcontainerApp0-ab1234"),
},
},
},
MaxInactiveRevisions: to.Ptr[int32](10),
Runtime: &armappcontainers.Runtime{
Java: &armappcontainers.RuntimeJava{
EnableMetrics: to.Ptr(true),
},
},
Service: &armappcontainers.Service{
Type: to.Ptr("redis"),
},
},
EnvironmentID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube"),
Template: &armappcontainers.Template{
Containers: []*armappcontainers.Container{
{
Name: to.Ptr("testcontainerApp0"),
Image: to.Ptr("repo/testcontainerApp0:v1"),
Probes: []*armappcontainers.ContainerAppProbe{
{
Type: to.Ptr(armappcontainers.TypeLiveness),
HTTPGet: &armappcontainers.ContainerAppProbeHTTPGet{
Path: to.Ptr("/health"),
HTTPHeaders: []*armappcontainers.ContainerAppProbeHTTPGetHTTPHeadersItem{
{
Name: to.Ptr("Custom-Header"),
Value: to.Ptr("Awesome"),
},
},
Port: to.Ptr[int32](8080),
},
InitialDelaySeconds: to.Ptr[int32](3),
PeriodSeconds: to.Ptr[int32](3),
},
},
VolumeMounts: []*armappcontainers.VolumeMount{
{
MountPath: to.Ptr("/mnt/path1"),
SubPath: to.Ptr("subPath1"),
VolumeName: to.Ptr("azurefile"),
},
{
MountPath: to.Ptr("/mnt/path2"),
SubPath: to.Ptr("subPath2"),
VolumeName: to.Ptr("nfsazurefile"),
},
},
},
},
InitContainers: []*armappcontainers.InitContainer{
{
Name: to.Ptr("testinitcontainerApp0"),
Args: []*string{
to.Ptr("-c"),
to.Ptr("while true; do echo hello; sleep 10;done"),
},
Command: []*string{
to.Ptr("/bin/sh"),
},
Image: to.Ptr("repo/testcontainerApp0:v4"),
Resources: &armappcontainers.ContainerResources{
CPU: to.Ptr[float64](0.2),
Memory: to.Ptr("100Mi"),
},
},
},
Scale: &armappcontainers.Scale{
CooldownPeriod: to.Ptr[int32](350),
MaxReplicas: to.Ptr[int32](5),
MinReplicas: to.Ptr[int32](1),
PollingInterval: to.Ptr[int32](35),
Rules: []*armappcontainers.ScaleRule{
{
Name: to.Ptr("httpscalingrule"),
Custom: &armappcontainers.CustomScaleRule{
Type: to.Ptr("http"),
Metadata: map[string]*string{
"concurrentRequests": to.Ptr("50"),
},
},
},
{
Name: to.Ptr("servicebus"),
Custom: &armappcontainers.CustomScaleRule{
Type: to.Ptr("azure-servicebus"),
Identity: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity"),
Metadata: map[string]*string{
"messageCount": to.Ptr("5"),
"namespace": to.Ptr("mynamespace"),
"queueName": to.Ptr("myqueue"),
},
},
},
{
Name: to.Ptr("azure-queue"),
AzureQueue: &armappcontainers.QueueScaleRule{
AccountName: to.Ptr("account1"),
Identity: to.Ptr("system"),
QueueLength: to.Ptr[int32](1),
QueueName: to.Ptr("queue1"),
},
},
},
},
ServiceBinds: []*armappcontainers.ServiceBind{
{
Name: to.Ptr("redisService"),
ServiceID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/containerApps/redisService"),
},
},
Volumes: []*armappcontainers.Volume{
{
Name: to.Ptr("azurefile"),
StorageName: to.Ptr("storage"),
StorageType: to.Ptr(armappcontainers.StorageTypeAzureFile),
},
{
Name: to.Ptr("nfsazurefile"),
StorageName: to.Ptr("nfsStorage"),
StorageType: to.Ptr(armappcontainers.StorageTypeNfsAzureFile),
},
},
},
WorkloadProfileName: to.Ptr("My-GP-01"),
},
}, nil)
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
res, err := poller.PollUntilDone(ctx, nil)
if err != nil {
log.Fatalf("failed to poll the result: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armappcontainers.ContainerAppsClientCreateOrUpdateResponse{
// ContainerApp: armappcontainers.ContainerApp{
// Name: to.Ptr("testcontainerApp0"),
// Type: to.Ptr("Microsoft.App/containerApps"),
// ID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/containerApps/testcontainerApp0"),
// Identity: &armappcontainers.ManagedServiceIdentity{
// Type: to.Ptr(armappcontainers.ManagedServiceIdentityTypeSystemAssignedUserAssigned),
// PrincipalID: to.Ptr("24adfa4f-dedf-8dc0-ca29-b6d1a69ab319"),
// TenantID: to.Ptr("23adfa4f-eedf-1dc0-ba29-a6d1a69ab3d0"),
// UserAssignedIdentities: map[string]*armappcontainers.UserAssignedIdentity{
// "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity": &armappcontainers.UserAssignedIdentity{
// ClientID: to.Ptr("14adfa4f-eedf-1dc0-ba29-a6d1a69ab3df"),
// PrincipalID: to.Ptr("74adfa4f-dedf-8dc0-ca29-b6d1a69ab312"),
// },
// },
// },
// Location: to.Ptr("East US"),
// Properties: &armappcontainers.ContainerAppProperties{
// Configuration: &armappcontainers.Configuration{
// Dapr: &armappcontainers.Dapr{
// AppHealth: &armappcontainers.DaprAppHealth{
// Path: to.Ptr("/health"),
// Enabled: to.Ptr(true),
// ProbeIntervalSeconds: to.Ptr[int32](3),
// ProbeTimeoutMilliseconds: to.Ptr[int32](1000),
// Threshold: to.Ptr[int32](3),
// },
// AppPort: to.Ptr[int32](3000),
// AppProtocol: to.Ptr(armappcontainers.AppProtocolHTTP),
// Enabled: to.Ptr(true),
// HTTPReadBufferSize: to.Ptr[int32](30),
// MaxConcurrency: to.Ptr[int32](10),
// },
// IdentitySettings: []*armappcontainers.IdentitySettings{
// {
// Identity: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity"),
// Lifecycle: to.Ptr(armappcontainers.IdentitySettingsLifeCycleAll),
// },
// {
// Identity: to.Ptr("system"),
// Lifecycle: to.Ptr(armappcontainers.IdentitySettingsLifeCycleInit),
// },
// },
// Ingress: &armappcontainers.Ingress{
// CustomDomains: []*armappcontainers.CustomDomain{
// {
// Name: to.Ptr("www.my-name.com"),
// BindingType: to.Ptr(armappcontainers.BindingTypeSniEnabled),
// CertificateID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube/certificates/my-certificate-for-my-name-dot-com"),
// },
// {
// Name: to.Ptr("www.my-other-name.com"),
// BindingType: to.Ptr(armappcontainers.BindingTypeSniEnabled),
// CertificateID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube/certificates/my-certificate-for-my-other-name-dot-com"),
// },
// },
// External: to.Ptr(true),
// Fqdn: to.Ptr("testcontainerApp0.demokube-t24clv0g.eastus.containerApps.k4apps.io"),
// IPSecurityRestrictions: []*armappcontainers.IPSecurityRestrictionRule{
// {
// Name: to.Ptr("Allow work IP A subnet"),
// Description: to.Ptr("Allowing all IP's within the subnet below to access containerapp"),
// Action: to.Ptr(armappcontainers.ActionAllow),
// IPAddressRange: to.Ptr("192.168.1.1/32"),
// },
// {
// Name: to.Ptr("Allow work IP B subnet"),
// Description: to.Ptr("Allowing all IP's within the subnet below to access containerapp"),
// Action: to.Ptr(armappcontainers.ActionAllow),
// IPAddressRange: to.Ptr("192.168.1.1/8"),
// },
// },
// StickySessions: &armappcontainers.IngressStickySessions{
// Affinity: to.Ptr(armappcontainers.AffinitySticky),
// },
// TargetPort: to.Ptr[int32](3000),
// Traffic: []*armappcontainers.TrafficWeight{
// {
// RevisionName: to.Ptr("testcontainerApp0-ab1234"),
// },
// {
// Label: to.Ptr("staging"),
// RevisionName: to.Ptr("testcontainerApp0-ab4321"),
// },
// },
// Transport: to.Ptr(armappcontainers.IngressTransportMethodAuto),
// },
// Runtime: &armappcontainers.Runtime{
// Java: &armappcontainers.RuntimeJava{
// EnableMetrics: to.Ptr(true),
// },
// },
// },
// EventStreamEndpoint: to.Ptr("testEndpoint"),
// LatestReadyRevisionName: to.Ptr("testcontainerApp0-pjxhsye"),
// LatestRevisionFqdn: to.Ptr("testcontainerApp0-pjxhsye.demokube-t24clv0g.eastus.containerApps.k4apps.io"),
// ManagedEnvironmentID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube"),
// ProvisioningState: to.Ptr(armappcontainers.ContainerAppProvisioningStateSucceeded),
// RunningStatus: to.Ptr(armappcontainers.ContainerAppRunningStatusRunning),
// Template: &armappcontainers.Template{
// Containers: []*armappcontainers.Container{
// {
// Name: to.Ptr("testcontainerApp0"),
// Image: to.Ptr("repo/testcontainerApp0:v4"),
// Probes: []*armappcontainers.ContainerAppProbe{
// {
// Type: to.Ptr(armappcontainers.TypeLiveness),
// HTTPGet: &armappcontainers.ContainerAppProbeHTTPGet{
// Path: to.Ptr("/health"),
// HTTPHeaders: []*armappcontainers.ContainerAppProbeHTTPGetHTTPHeadersItem{
// {
// Name: to.Ptr("Custom-Header"),
// Value: to.Ptr("Awesome"),
// },
// },
// Port: to.Ptr[int32](8080),
// },
// InitialDelaySeconds: to.Ptr[int32](3),
// PeriodSeconds: to.Ptr[int32](3),
// },
// },
// Resources: &armappcontainers.ContainerResources{
// CPU: to.Ptr[float64](0.2),
// Memory: to.Ptr("100Mi"),
// },
// VolumeMounts: []*armappcontainers.VolumeMount{
// {
// MountPath: to.Ptr("/mnt/path1"),
// SubPath: to.Ptr("subPath1"),
// VolumeName: to.Ptr("azurefile"),
// },
// {
// MountPath: to.Ptr("/mnt/path2"),
// SubPath: to.Ptr("subPath2"),
// VolumeName: to.Ptr("nfsazurefile"),
// },
// },
// },
// },
// InitContainers: []*armappcontainers.InitContainer{
// {
// Name: to.Ptr("testinitcontainerApp0"),
// Args: []*string{
// to.Ptr("-c"),
// to.Ptr("while true; do echo hello; sleep 10;done"),
// },
// Command: []*string{
// to.Ptr("/bin/sh"),
// },
// Image: to.Ptr("repo/testcontainerApp0:v4"),
// Resources: &armappcontainers.ContainerResources{
// CPU: to.Ptr[float64](0.2),
// Memory: to.Ptr("100Mi"),
// },
// },
// },
// Scale: &armappcontainers.Scale{
// CooldownPeriod: to.Ptr[int32](350),
// MaxReplicas: to.Ptr[int32](5),
// MinReplicas: to.Ptr[int32](1),
// PollingInterval: to.Ptr[int32](35),
// Rules: []*armappcontainers.ScaleRule{
// {
// Name: to.Ptr("httpscalingrule"),
// HTTP: &armappcontainers.HTTPScaleRule{
// Metadata: map[string]*string{
// "concurrentRequests": to.Ptr("50"),
// },
// },
// },
// {
// Name: to.Ptr("servicebus"),
// Custom: &armappcontainers.CustomScaleRule{
// Type: to.Ptr("azure-servicebus"),
// Identity: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity"),
// Metadata: map[string]*string{
// "messageCount": to.Ptr("5"),
// "namespace": to.Ptr("mynamespace"),
// "queueName": to.Ptr("myqueue"),
// },
// },
// },
// {
// Name: to.Ptr("azure-queue"),
// AzureQueue: &armappcontainers.QueueScaleRule{
// AccountName: to.Ptr("account1"),
// Identity: to.Ptr("system"),
// QueueLength: to.Ptr[int32](1),
// QueueName: to.Ptr("queue1"),
// },
// },
// },
// },
// Volumes: []*armappcontainers.Volume{
// {
// Name: to.Ptr("azurefile"),
// StorageName: to.Ptr("storage"),
// StorageType: to.Ptr(armappcontainers.StorageTypeAzureFile),
// },
// {
// Name: to.Ptr("nfsazurefile"),
// StorageName: to.Ptr("nfsStorage"),
// StorageType: to.Ptr(armappcontainers.StorageTypeNfsAzureFile),
// },
// },
// },
// WorkloadProfileName: to.Ptr("My-GP-01"),
// },
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
const { ContainerAppsAPIClient } = require("@azure/arm-appcontainers");
const { DefaultAzureCredential } = require("@azure/identity");
/**
* This sample demonstrates how to create or update a Container App.
*
* @summary create or update a Container App.
* x-ms-original-file: 2026-07-01/ContainerApps_CreateOrUpdate.json
*/
async function createOrUpdateContainerApp() {
const credential = new DefaultAzureCredential();
const subscriptionId = "34adfa4f-cedf-4dc0-ba29-b6d1a69ab345";
const client = new ContainerAppsAPIClient(credential, subscriptionId);
const result = await client.containerApps.createOrUpdate("rg", "testcontainerApp0", {
identity: {
type: "SystemAssigned,UserAssigned",
userAssignedIdentities: {
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity":
{},
},
},
location: "East US",
configuration: {
dapr: {
appHealth: {
path: "/health",
enabled: true,
probeIntervalSeconds: 3,
probeTimeoutMilliseconds: 1000,
threshold: 3,
},
appPort: 3000,
appProtocol: "http",
enableApiLogging: true,
enabled: true,
httpMaxRequestSize: 10,
httpReadBufferSize: 30,
logLevel: "debug",
maxConcurrency: 10,
},
identitySettings: [
{
identity:
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity",
lifecycle: "All",
},
{ identity: "system", lifecycle: "Init" },
],
ingress: {
additionalPortMappings: [
{ external: true, targetPort: 1234 },
{ exposedPort: 3456, external: false, targetPort: 2345 },
],
clientCertificateMode: "accept",
corsPolicy: {
allowCredentials: true,
allowedHeaders: ["HEADER1", "HEADER2"],
allowedMethods: ["GET", "POST"],
allowedOrigins: ["https://a.test.com", "https://b.test.com"],
exposeHeaders: ["HEADER3", "HEADER4"],
maxAge: 1234,
},
customDomains: [
{
name: "www.my-name.com",
bindingType: "SniEnabled",
certificateId:
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube/certificates/my-certificate-for-my-name-dot-com",
},
{
name: "www.my-other-name.com",
bindingType: "SniEnabled",
certificateId:
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube/certificates/my-certificate-for-my-other-name-dot-com",
},
],
external: true,
ipSecurityRestrictions: [
{
name: "Allow work IP A subnet",
description: "Allowing all IP's within the subnet below to access containerapp",
action: "Allow",
ipAddressRange: "192.168.1.1/32",
},
{
name: "Allow work IP B subnet",
description: "Allowing all IP's within the subnet below to access containerapp",
action: "Allow",
ipAddressRange: "192.168.1.1/8",
},
],
stickySessions: { affinity: "sticky" },
targetPort: 3000,
traffic: [{ label: "production", revisionName: "testcontainerApp0-ab1234" }],
},
maxInactiveRevisions: 10,
runtime: { java: { enableMetrics: true } },
service: { type: "redis" },
},
environmentId:
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube",
template: {
containers: [
{
name: "testcontainerApp0",
image: "repo/testcontainerApp0:v1",
probes: [
{
type: "Liveness",
httpGet: {
path: "/health",
httpHeaders: [{ name: "Custom-Header", value: "Awesome" }],
port: 8080,
},
initialDelaySeconds: 3,
periodSeconds: 3,
},
],
volumeMounts: [
{ mountPath: "/mnt/path1", subPath: "subPath1", volumeName: "azurefile" },
{ mountPath: "/mnt/path2", subPath: "subPath2", volumeName: "nfsazurefile" },
],
},
],
initContainers: [
{
name: "testinitcontainerApp0",
args: ["-c", "while true; do echo hello; sleep 10;done"],
command: ["/bin/sh"],
image: "repo/testcontainerApp0:v4",
resources: { cpu: 0.2, memory: "100Mi" },
},
],
scale: {
cooldownPeriod: 350,
maxReplicas: 5,
minReplicas: 1,
pollingInterval: 35,
rules: [
{
name: "httpscalingrule",
custom: { type: "http", metadata: { concurrentRequests: "50" } },
},
{
name: "servicebus",
custom: {
type: "azure-servicebus",
identity:
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity",
metadata: { messageCount: "5", namespace: "mynamespace", queueName: "myqueue" },
},
},
{
name: "azure-queue",
azureQueue: {
accountName: "account1",
identity: "system",
queueLength: 1,
queueName: "queue1",
},
},
],
},
serviceBinds: [
{
name: "redisService",
serviceId:
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/containerApps/redisService",
},
],
volumes: [
{ name: "azurefile", storageName: "storage", storageType: "AzureFile" },
{ name: "nfsazurefile", storageName: "nfsStorage", storageType: "NfsAzureFile" },
],
},
workloadProfileName: "My-GP-01",
});
console.log(result);
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Sample response
{
"name": "testcontainerApp0",
"type": "Microsoft.App/containerApps",
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/containerApps/testcontainerApp0",
"identity": {
"type": "SystemAssigned,UserAssigned",
"principalId": "24adfa4f-dedf-8dc0-ca29-b6d1a69ab319",
"tenantId": "23adfa4f-eedf-1dc0-ba29-a6d1a69ab3d0",
"userAssignedIdentities": {
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity": {
"clientId": "14adfa4f-eedf-1dc0-ba29-a6d1a69ab3df",
"principalId": "74adfa4f-dedf-8dc0-ca29-b6d1a69ab312"
}
}
},
"location": "East US",
"properties": {
"configuration": {
"dapr": {
"appHealth": {
"path": "/health",
"enabled": true,
"probeIntervalSeconds": 3,
"probeTimeoutMilliseconds": 1000,
"threshold": 3
},
"appPort": 3000,
"appProtocol": "http",
"enabled": true,
"httpReadBufferSize": 30,
"maxConcurrency": 10
},
"identitySettings": [
{
"identity": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity",
"lifecycle": "All"
},
{
"identity": "system",
"lifecycle": "Init"
}
],
"ingress": {
"customDomains": [
{
"name": "www.my-name.com",
"bindingType": "SniEnabled",
"certificateId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube/certificates/my-certificate-for-my-name-dot-com"
},
{
"name": "www.my-other-name.com",
"bindingType": "SniEnabled",
"certificateId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube/certificates/my-certificate-for-my-other-name-dot-com"
}
],
"external": true,
"fqdn": "testcontainerApp0.demokube-t24clv0g.eastus.containerApps.k4apps.io",
"ipSecurityRestrictions": [
{
"name": "Allow work IP A subnet",
"description": "Allowing all IP's within the subnet below to access containerapp",
"action": "Allow",
"ipAddressRange": "192.168.1.1/32"
},
{
"name": "Allow work IP B subnet",
"description": "Allowing all IP's within the subnet below to access containerapp",
"action": "Allow",
"ipAddressRange": "192.168.1.1/8"
}
],
"stickySessions": {
"affinity": "sticky"
},
"targetPort": 3000,
"traffic": [
{
"revisionName": "testcontainerApp0-ab1234"
},
{
"label": "staging",
"revisionName": "testcontainerApp0-ab4321"
}
],
"transport": "auto"
},
"runtime": {
"java": {
"enableMetrics": true
}
}
},
"eventStreamEndpoint": "testEndpoint",
"latestReadyRevisionName": "testcontainerApp0-pjxhsye",
"latestRevisionFqdn": "testcontainerApp0-pjxhsye.demokube-t24clv0g.eastus.containerApps.k4apps.io",
"managedEnvironmentId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube",
"provisioningState": "Succeeded",
"runningStatus": "Running",
"template": {
"containers": [
{
"name": "testcontainerApp0",
"image": "repo/testcontainerApp0:v4",
"probes": [
{
"type": "Liveness",
"httpGet": {
"path": "/health",
"httpHeaders": [
{
"name": "Custom-Header",
"value": "Awesome"
}
],
"port": 8080
},
"initialDelaySeconds": 3,
"periodSeconds": 3
}
],
"resources": {
"cpu": 0.2,
"memory": "100Mi"
},
"volumeMounts": [
{
"mountPath": "/mnt/path1",
"subPath": "subPath1",
"volumeName": "azurefile"
},
{
"mountPath": "/mnt/path2",
"subPath": "subPath2",
"volumeName": "nfsazurefile"
}
]
}
],
"initContainers": [
{
"name": "testinitcontainerApp0",
"args": [
"-c",
"while true; do echo hello; sleep 10;done"
],
"command": [
"/bin/sh"
],
"image": "repo/testcontainerApp0:v4",
"resources": {
"cpu": 0.2,
"memory": "100Mi"
}
}
],
"scale": {
"cooldownPeriod": 350,
"maxReplicas": 5,
"minReplicas": 1,
"pollingInterval": 35,
"rules": [
{
"name": "httpscalingrule",
"http": {
"metadata": {
"concurrentRequests": "50"
}
}
},
{
"name": "servicebus",
"custom": {
"type": "azure-servicebus",
"identity": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity",
"metadata": {
"messageCount": "5",
"namespace": "mynamespace",
"queueName": "myqueue"
}
}
},
{
"name": "azure-queue",
"azureQueue": {
"accountName": "account1",
"identity": "system",
"queueLength": 1,
"queueName": "queue1"
}
}
]
},
"volumes": [
{
"name": "azurefile",
"storageName": "storage",
"storageType": "AzureFile"
},
{
"name": "nfsazurefile",
"storageName": "nfsStorage",
"storageType": "NfsAzureFile"
}
]
},
"workloadProfileName": "My-GP-01"
}
}
{
"name": "testcontainerApp0",
"type": "Microsoft.App/containerApps",
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/containerApps/testcontainerApp0",
"identity": {
"type": "SystemAssigned,UserAssigned",
"principalId": "24adfa4f-dedf-8dc0-ca29-b6d1a69ab319",
"tenantId": "23adfa4f-eedf-1dc0-ba29-a6d1a69ab3d0",
"userAssignedIdentities": {
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity": {
"clientId": "14adfa4f-eedf-1dc0-ba29-a6d1a69ab3df",
"principalId": "74adfa4f-dedf-8dc0-ca29-b6d1a69ab312"
}
}
},
"location": "East US",
"properties": {
"configuration": {
"dapr": {
"appHealth": {
"path": "/health",
"enabled": true,
"probeIntervalSeconds": 3,
"probeTimeoutMilliseconds": 1000,
"threshold": 3
},
"appPort": 3000,
"appProtocol": "http",
"enabled": true,
"httpReadBufferSize": 30,
"maxConcurrency": 10
},
"identitySettings": [
{
"identity": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity",
"lifecycle": "All"
},
{
"identity": "system",
"lifecycle": "Init"
}
],
"ingress": {
"external": true,
"fqdn": "testcontainerApp0.demokube-t24clv0g.eastus.containerApps.k4apps.io",
"targetPort": 3000,
"traffic": [
{
"revisionName": "testcontainerApp0-ab1234"
},
{
"label": "staging",
"revisionName": "testcontainerApp0-ab4321"
}
],
"transport": "auto"
},
"runtime": {
"java": {
"enableMetrics": true
}
}
},
"eventStreamEndpoint": "testEndpoint",
"latestRevisionFqdn": "testcontainerApp0-pjxhsye.demokube-t24clv0g.eastus.containerApps.k4apps.io",
"managedEnvironmentId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube",
"provisioningState": "InProgress",
"runningStatus": "Progressing",
"template": {
"containers": [
{
"name": "testcontainerApp0",
"image": "repo/testcontainerApp0:v4",
"probes": [
{
"type": "Liveness",
"httpGet": {
"path": "/health",
"httpHeaders": [
{
"name": "Custom-Header",
"value": "Awesome"
}
],
"port": 8080
},
"initialDelaySeconds": 3,
"periodSeconds": 3
}
],
"resources": {
"cpu": 0.2,
"memory": "100Mi"
},
"volumeMounts": [
{
"mountPath": "/mnt/path1",
"subPath": "subPath1",
"volumeName": "azurefile"
},
{
"mountPath": "/mnt/path2",
"subPath": "subPath2",
"volumeName": "nfsazurefile"
}
]
}
],
"initContainers": [
{
"name": "testinitcontainerApp0",
"args": [
"-c",
"while true; do echo hello; sleep 10;done"
],
"command": [
"/bin/sh"
],
"image": "repo/testcontainerApp0:v4",
"resources": {
"cpu": 0.2,
"memory": "100Mi"
}
}
],
"scale": {
"cooldownPeriod": 350,
"maxReplicas": 5,
"minReplicas": 1,
"pollingInterval": 35,
"rules": [
{
"name": "httpscalingrule",
"http": {
"metadata": {
"concurrentRequests": "50"
}
}
},
{
"name": "servicebus",
"custom": {
"type": "azure-servicebus",
"identity": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/rg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myidentity",
"metadata": {
"messageCount": "5",
"namespace": "mynamespace",
"queueName": "myqueue"
}
}
},
{
"name": "azure-queue",
"azureQueue": {
"accountName": "account1",
"identity": "system",
"queueLength": 1,
"queueName": "queue1"
}
}
]
},
"volumes": [
{
"name": "azurefile",
"storageName": "storage",
"storageType": "AzureFile"
},
{
"name": "nfsazurefile",
"storageName": "nfsStorage",
"storageType": "NfsAzureFile"
}
]
}
}
}
Create or Update Container App with per-app outbound VNet subnet
Sample request
PUT https://management.azure.com/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/containerApps/testcontainerApp0?api-version=2026-07-01
{
"location": "East US",
"properties": {
"environmentId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/expressenv",
"networking": {
"outboundVnetSubnetId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.Network/virtualNetworks/myvnet/subnets/appsubnet"
},
"template": {
"containers": [
{
"name": "testcontainerApp0",
"image": "repo/testcontainerApp0:v1",
"resources": {
"cpu": 0.2,
"memory": "100Mi"
}
}
]
}
}
}
import com.azure.resourcemanager.appcontainers.models.Container;
import com.azure.resourcemanager.appcontainers.models.ContainerAppNetworkingConfiguration;
import com.azure.resourcemanager.appcontainers.models.ContainerResources;
import com.azure.resourcemanager.appcontainers.models.Template;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
/**
* Samples for ContainerApps CreateOrUpdate.
*/
public final class Main {
/*
* x-ms-original-file: 2026-07-01/ContainerApps_CreateOrUpdate_Networking.json
*/
/**
* Sample code: Create or Update Container App with per-app outbound VNet subnet.
*
* @param manager Entry point to ContainerAppsApiManager.
*/
public static void createOrUpdateContainerAppWithPerAppOutboundVNetSubnet(
com.azure.resourcemanager.appcontainers.ContainerAppsApiManager manager) {
manager.containerApps().define("testcontainerApp0").withRegion("East US").withExistingResourceGroup("rg")
.withEnvironmentId(
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/expressenv")
.withNetworking(new ContainerAppNetworkingConfiguration().withOutboundVnetSubnetId(
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.Network/virtualNetworks/myvnet/subnets/appsubnet"))
.withTemplate(new Template().withContainers(
Arrays.asList(new Container().withImage("repo/testcontainerApp0:v1").withName("testcontainerApp0")
.withResources(new ContainerResources().withCpu(0.2D).withMemory("100Mi")))))
.create();
}
// Use "Map.of" if available
@SuppressWarnings("unchecked")
private static <T> Map<String, T> mapOf(Object... inputs) {
Map<String, T> map = new HashMap<>();
for (int i = 0; i < inputs.length; i += 2) {
String key = (String) inputs[i];
T value = (T) inputs[i + 1];
map.put(key, value);
}
return map;
}
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
from azure.identity import DefaultAzureCredential
from azure.mgmt.appcontainers import ContainerAppsAPIClient
"""
# PREREQUISITES
pip install azure-identity
pip install azure-mgmt-appcontainers
# USAGE
python container_apps_create_or_update_networking.py
Before run the sample, please set the values of the client ID, tenant ID and client secret
of the AAD application as environment variables: AZURE_CLIENT_ID, AZURE_TENANT_ID,
AZURE_CLIENT_SECRET. For more info about how to get the value, please see:
https://docs.microsoft.com/azure/active-directory/develop/howto-create-service-principal-portal
"""
def main():
client = ContainerAppsAPIClient(
credential=DefaultAzureCredential(),
subscription_id="SUBSCRIPTION_ID",
)
response = client.container_apps.begin_create_or_update(
resource_group_name="rg",
container_app_name="testcontainerApp0",
container_app_envelope={
"location": "East US",
"properties": {
"environmentId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/expressenv",
"networking": {
"outboundVnetSubnetId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.Network/virtualNetworks/myvnet/subnets/appsubnet"
},
"template": {
"containers": [
{
"image": "repo/testcontainerApp0:v1",
"name": "testcontainerApp0",
"resources": {"cpu": 0.2, "memory": "100Mi"},
}
]
},
},
},
).result()
print(response)
# x-ms-original-file: 2026-07-01/ContainerApps_CreateOrUpdate_Networking.json
if __name__ == "__main__":
main()
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
package armappcontainers_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/appcontainers/armappcontainers/v5"
)
// Generated from example definition: 2026-07-01/ContainerApps_CreateOrUpdate_Networking.json
func ExampleContainerAppsClient_BeginCreateOrUpdate_createOrUpdateContainerAppWithPerAppOutboundVNetSubnet() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armappcontainers.NewClientFactory("34adfa4f-cedf-4dc0-ba29-b6d1a69ab345", cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
poller, err := clientFactory.NewContainerAppsClient().BeginCreateOrUpdate(ctx, "rg", "testcontainerApp0", armappcontainers.ContainerApp{
Location: to.Ptr("East US"),
Properties: &armappcontainers.ContainerAppProperties{
EnvironmentID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/expressenv"),
Networking: &armappcontainers.ContainerAppNetworkingConfiguration{
OutboundVnetSubnetID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.Network/virtualNetworks/myvnet/subnets/appsubnet"),
},
Template: &armappcontainers.Template{
Containers: []*armappcontainers.Container{
{
Name: to.Ptr("testcontainerApp0"),
Image: to.Ptr("repo/testcontainerApp0:v1"),
Resources: &armappcontainers.ContainerResources{
CPU: to.Ptr[float64](0.2),
Memory: to.Ptr("100Mi"),
},
},
},
},
},
}, nil)
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
res, err := poller.PollUntilDone(ctx, nil)
if err != nil {
log.Fatalf("failed to poll the result: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armappcontainers.ContainerAppsClientCreateOrUpdateResponse{
// ContainerApp: armappcontainers.ContainerApp{
// Name: to.Ptr("testcontainerApp0"),
// Type: to.Ptr("Microsoft.App/containerApps"),
// ID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/containerApps/testcontainerApp0"),
// Location: to.Ptr("East US"),
// Properties: &armappcontainers.ContainerAppProperties{
// ProvisioningState: to.Ptr(armappcontainers.ContainerAppProvisioningStateSucceeded),
// EnvironmentID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/expressenv"),
// Networking: &armappcontainers.ContainerAppNetworkingConfiguration{
// OutboundVnetSubnetID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.Network/virtualNetworks/myvnet/subnets/appsubnet"),
// },
// },
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
const { ContainerAppsAPIClient } = require("@azure/arm-appcontainers");
const { DefaultAzureCredential } = require("@azure/identity");
/**
* This sample demonstrates how to create or update a Container App.
*
* @summary create or update a Container App.
* x-ms-original-file: 2026-07-01/ContainerApps_CreateOrUpdate_Networking.json
*/
async function createOrUpdateContainerAppWithPerAppOutboundVNetSubnet() {
const credential = new DefaultAzureCredential();
const subscriptionId = "34adfa4f-cedf-4dc0-ba29-b6d1a69ab345";
const client = new ContainerAppsAPIClient(credential, subscriptionId);
const result = await client.containerApps.createOrUpdate("rg", "testcontainerApp0", {
location: "East US",
environmentId:
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/expressenv",
networking: {
outboundVnetSubnetId:
"/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.Network/virtualNetworks/myvnet/subnets/appsubnet",
},
template: {
containers: [
{
name: "testcontainerApp0",
image: "repo/testcontainerApp0:v1",
resources: { cpu: 0.2, memory: "100Mi" },
},
],
},
});
console.log(result);
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Sample response
{
"name": "testcontainerApp0",
"type": "Microsoft.App/containerApps",
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/containerApps/testcontainerApp0",
"location": "East US",
"properties": {
"provisioningState": "Succeeded",
"environmentId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/expressenv",
"networking": {
"outboundVnetSubnetId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.Network/virtualNetworks/myvnet/subnets/appsubnet"
}
}
}
{
"name": "testcontainerApp0",
"type": "Microsoft.App/containerApps",
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/containerApps/testcontainerApp0",
"location": "East US",
"properties": {
"provisioningState": "InProgress",
"environmentId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/expressenv",
"networking": {
"outboundVnetSubnetId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.Network/virtualNetworks/myvnet/subnets/appsubnet"
}
}
}
Create or Update FunctionApp Kind
Sample request
PUT https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg/providers/Microsoft.App/containerApps/testcontainerAppFunctionKind?api-version=2026-07-01
{
"kind": "functionapp",
"location": "East Us",
"managedBy": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg/providers/Microsoft.Web/sites/testcontainerAppFunctionKind",
"properties": {
"configuration": {
"activeRevisionsMode": "Single",
"ingress": {
"allowInsecure": false,
"external": true,
"targetPort": 80
}
},
"managedEnvironmentId": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/testmanagedenv3",
"template": {
"containers": [
{
"name": "function-app-container",
"env": [
{
"name": "AzureWebJobsStorage",
"value": "DefaultEndpointsProtocol=https;AccountName=mystorageaccount;AccountKey=mykey;EndpointSuffix=core.windows.net"
},
{
"name": "FUNCTIONS_WORKER_RUNTIME",
"value": "dotnet"
},
{
"name": "WEBSITES_ENABLE_APP_SERVICE_STORAGE",
"value": "false"
}
],
"image": "mcr.microsoft.com/azure-functions/dotnet:4",
"resources": {
"cpu": 0.5,
"memory": "1.0Gi"
}
}
],
"scale": {
"allowScalingRuleOverride": true,
"cooldownPeriod": 300,
"maxReplicas": 10,
"minReplicas": 0,
"pollingInterval": 30
}
}
}
}
import com.azure.resourcemanager.appcontainers.models.ActiveRevisionsMode;
import com.azure.resourcemanager.appcontainers.models.Configuration;
import com.azure.resourcemanager.appcontainers.models.Container;
import com.azure.resourcemanager.appcontainers.models.ContainerResources;
import com.azure.resourcemanager.appcontainers.models.EnvironmentVar;
import com.azure.resourcemanager.appcontainers.models.Ingress;
import com.azure.resourcemanager.appcontainers.models.Kind;
import com.azure.resourcemanager.appcontainers.models.Scale;
import com.azure.resourcemanager.appcontainers.models.Template;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
/**
* Samples for ContainerApps CreateOrUpdate.
*/
public final class Main {
/*
* x-ms-original-file: 2026-07-01/ContainerApps_Kind_FunctionApp_CreateOrUpdate.json
*/
/**
* Sample code: Create or Update FunctionApp Kind.
*
* @param manager Entry point to ContainerAppsApiManager.
*/
public static void
createOrUpdateFunctionAppKind(com.azure.resourcemanager.appcontainers.ContainerAppsApiManager manager) {
manager.containerApps().define("testcontainerAppFunctionKind").withRegion("East Us")
.withExistingResourceGroup("rg")
.withManagedBy(
"/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg/providers/Microsoft.Web/sites/testcontainerAppFunctionKind")
.withKind(Kind.FUNCTIONAPP)
.withManagedEnvironmentId(
"/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/testmanagedenv3")
.withConfiguration(new Configuration().withActiveRevisionsMode(ActiveRevisionsMode.SINGLE)
.withIngress(new Ingress().withExternal(true).withTargetPort(80).withAllowInsecure(false)))
.withTemplate(new Template().withContainers(Arrays.asList(new Container()
.withImage("mcr.microsoft.com/azure-functions/dotnet:4").withName("function-app-container")
.withEnv(Arrays.asList(new EnvironmentVar().withName("AzureWebJobsStorage").withValue(
"DefaultEndpointsProtocol=https;AccountName=mystorageaccount;AccountKey=mykey;EndpointSuffix=core.windows.net"),
new EnvironmentVar().withName("FUNCTIONS_WORKER_RUNTIME").withValue("dotnet"),
new EnvironmentVar().withName("WEBSITES_ENABLE_APP_SERVICE_STORAGE").withValue("false")))
.withResources(new ContainerResources().withCpu(0.5D).withMemory("1.0Gi"))))
.withScale(new Scale().withMinReplicas(0).withMaxReplicas(10).withCooldownPeriod(300)
.withPollingInterval(30).withAllowScalingRuleOverride(true)))
.create();
}
// Use "Map.of" if available
@SuppressWarnings("unchecked")
private static <T> Map<String, T> mapOf(Object... inputs) {
Map<String, T> map = new HashMap<>();
for (int i = 0; i < inputs.length; i += 2) {
String key = (String) inputs[i];
T value = (T) inputs[i + 1];
map.put(key, value);
}
return map;
}
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
from azure.identity import DefaultAzureCredential
from azure.mgmt.appcontainers import ContainerAppsAPIClient
"""
# PREREQUISITES
pip install azure-identity
[...]
